unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TGQry, ODBCQry, Grids, DataCtrl, ExtCtrls, StdCtrls,
  Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DataGrid1: TDataGrid;
    ODBCQuery1: TODBCQuery;
    ODBCCon1: TODBCCon;
    StatusLabel: TLabel;
    RadioGroup1: TRadioGroup;
    UnDo: TSpeedButton;
    UnDelete: TSpeedButton;
    Delete: TSpeedButton;
    Insert: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ODBCQuery1AfterScroll(Sender: TComponent;
      ScrollBy: TScrollType; ScrollInfo: Longint);
    procedure RadioGroup1Click(Sender: TObject);
    procedure UnDoClick(Sender: TObject);
    procedure UnDeleteClick(Sender: TObject);
    procedure ODBCQuery1AfterActivate(Sender: TComponent);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ODBCQuery1.Active := True;
end;

procedure TForm1.ODBCQuery1AfterScroll(Sender: TComponent;
  ScrollBy: TScrollType; ScrollInfo: Longint);
begin
  Case ODBCQuery1.RowStatus of
    rsOriginal: StatusLabel.Caption := ' Unmodified';
    rsModified: StatusLabel.Caption := ' Modified';
    rsNew: StatusLabel.Caption := ' New Unmodified';
    rsNewModified: StatusLabel.Caption := ' New Modified';
    rsDeleted: StatusLabel.Caption := ' Deleted';
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  UnDelete.Enabled := False;
  UnDo.Enabled := False;
  Delete.Enabled := False;
  Insert.Enabled := False;

  Case RadioGroup1.ItemIndex of
    0:
    begin
      ODBCQuery1.Buffer := bData;
      UnDo.Enabled := True;
      Insert.Enabled := True;
      Delete.Enabled := True;
    end;
    1: ODBCQuery1.Buffer := bOriginal;
    2:
    begin
      UnDelete.Enabled := True;
      ODBCQuery1.Buffer := bDeleted;
    end;
  end;
  ODBCQuery1AfterActivate(ODBCQuery1);
end;

procedure TForm1.UnDoClick(Sender: TObject);
begin
  ODBCQuery1.UnDo;
end;

procedure TForm1.UnDeleteClick(Sender: TObject);
begin
  ODBCQuery1.UnDelete;
end;

procedure TForm1.ODBCQuery1AfterActivate(Sender: TComponent);
begin
  Case ODBCQuery1.RowStatus of
    rsOriginal: StatusLabel.Caption := ' Unmodified';
    rsModified: StatusLabel.Caption := ' Modified';
    rsNew: StatusLabel.Caption := ' New Unmodified';
    rsNewModified: StatusLabel.Caption := ' New Modified';
    rsDeleted: StatusLabel.Caption := ' Deleted';
  end;
end;

end.
